local T, C, L, G = unpack(Tukui)

-- Overriding defualt Tukui Skin Templates here if I can.
local frames = {
	CharacterFrame,
	FriendsFrame,
	SpellBookFrame.backdrop,
	QuestLogFrame,
	VideoOptionsFrame,
	InterfaceOptionsFrame,
	WorldMapFrame.backdrop,
	QuestFrame.backdrop,
	GossipFrame.backdrop,
	GameMenuFrame,
	WorldStateScoreFrame,
	MailFrame.backdrop,
	PVPFrame.backdrop,
	PVEFrame.backdrop,
	MerchantFrame,
	MerchantBuyBackItem,
	TukuiInstallFrame,
	ItemTextFrame,
	LFGDungeonReadyPopup,
	QuestLogDetailFrame,
	GuildInviteFrame,
	DressUpFrame.backdrop,
	ChatConfigFrame
}

local OnLoad = CreateFrame("Frame")
OnLoad:RegisterEvent("PLAYER_ENTERING_WORLD")
OnLoad:SetScript("OnEvent", function()
	for _,f in pairs(frames) do
		f:SetTemplate("Transparent")
		f:CreateBorder(true, true)
	end
end)

-----------------------------------------------
--Test to skin other frames
-----------------------------------------------

local myAddon = "FlyingUI"

local function SkinBlizzardFrames(self, event, addon)
	if(addon == myAddon) then

	elseif(addon == "Blizzard_AchievementUI") then
		AchievementFrame.backdrop:SetTemplate("Transparent")
		AchievementFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_ArchaeologyUI") then
		ArchaeologyFrame:SetTemplate("Transparent")
		ArchaeologyFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_AuctionUI") then
		AuctionFrame:SetTemplate("Transparent")
		AuctionFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_BarbershopUI") then
		BarberShopFrame:SetTemplate("Transparent")
		BarberShopFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_BindingUI") then
		KeyBindingFrame:SetTemplate( "Transparent")
		KeyBindingFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_Calendar") then
		CalendarFrame:SetTemplate("Transparent")
		CalendarCreateEventFrame:SetTemplate("Transparent")
		CalendarTexturePickerFrame:SetTemplate("Transparent")
		CalendarFrame:CreateBorder(true, true)
		CalendarCreateEventFrame:CreateBorder(true, true)
		CalendarTexturePickerFrame:CreateBorder(true, true)
		CalendarViewHolidayFrame:SetTemplate("Transparent")
		CalendarViewHolidayFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_TimeManager") then
		TimeManagerFrame:SetTemplate("Transparent")
		TimeManagerFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_TalentUI") then
		PlayerTalentFrame.backdrop:SetTemplate("Transparent")
		PlayerTalentFrame.backdrop:CreateBorder(true, true)
	elseif(addon == "Blizzard_GuildUI") then
		GuildFrame:SetTemplate("Transparent")
		GuildFrame:CreateBorder(true, true)
		GuildMemberDetailFrame:SetTemplate("Transparent")
		GuildMemberDetailFrame:CreateBorder(true, true)
		GuildLogFrame:SetTemplate("Transparent")
		GuildLogFrame:CreateBorder(true, true)
		GuildNewsFiltersFrame:SetTemplate("Transparent")
		GuildNewsFiltersFrame:CreateBorder(true, true)
		GuildTextEditFrame:SetTemplate("Transparent")
		GuildTextEditFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_GuildBankUI") then
		GuildBankFrame:SetTemplate("Transparent")
		GuildBankFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_MacroUI") then
		MacroFrame:SetTemplate("Transparent")
		MacroFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_VoidStorageUI") then
		VoidStorageFrame:SetTemplate("Transparent")
		VoidStorageFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_ReforgingUI") then
		ReforgingFrame:SetTemplate("Transparent")
		ReforgingFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_TrainerUI") then
		ClassTrainerFrame.backdrop:SetTemplate("Transparent")
		ClassTrainerFrame.backdrop:CreateBorder(true, true)
	elseif(addon == "Blizzard_InspectUI") then
		InspectFrame.backdrop:SetTemplate("Transparent")
		InspectFrame.backdrop:CreateBorder(true, true)
	elseif(addon == "Blizzard_TradeSkillUI") then
		TradeSkillFrame:SetTemplate("Transparent")
		TradeSkillFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_ItemAlterationUI") then
		TransmogrifyArtFrame:SetTemplate("Transparent")
		TransmogrifyArtFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_LookingForGuildUI") then
		LookingForGuildFrame:SetTemplate("Transparent")
		LookingForGuildFrame:CreateBorder(true, true)
	elseif(addon == "Blizzard_PetJournal") then
		PetJournalParent:SetTemplate("Transparent")
		PetJournalParent:CreateBorder(true, true)
	end
end

local Init = CreateFrame("Frame")
Init:RegisterEvent("ADDON_LOADED")
Init:SetScript("OnEvent", SkinBlizzardFrames)



-- Skin the bag frames.
if C.bags.enable ~= true then return end

local function BagsSlotUpdate(self, b)
	local scount = _G[b.frame:GetName().."Count"]
	scount:SetFont(T.CreateFontString())
	scount:Point("BOTTOMRIGHT", 0, 2)
end
hooksecurefunc(Stuffing, "SlotUpdate", BagsSlotUpdate)

local function BagsLayout(self, lb)
	local f

	if(lb) then
		f = self.bankFrame
	else
		f = self.frame

		f.gold:SetText(GetMoneyString(GetMoney(), 12))
		f.editbox:SetFont(T.CreateFontString())
		f.editbox:SetShadowOffset(0, 0)
		f.detail:SetFont(T.CreateFontString())
		f.detail:SetShadowOffset(0, 0)
		f.gold:SetFont(T.CreateFontString())
		f.gold:SetShadowOffset(0, 0)

		f.detail:ClearAllPoints()
		f.detail:Point("TOPLEFT", f, 12, -10)
		f.detail:Point("RIGHT", -(16 + 24), 0)
	end
	
	f:SetTemplate("Transparent")
	f:CreateShadow("Default")
end
hooksecurefunc(Stuffing, "Layout", BagsLayout)

TukuiBags:ClearAllPoints()
if C.chat.background == true then
TukuiBags:SetPoint("BOTTOM", TukuiChatBackgroundRight, "TOP", 0, 3)
else
TukuiBags:SetPoint("BOTTOM", TukuiInfoRight, "TOP", 0, 3)
end


local function BagsUpdateBankPosition(self, value)
	local bag = _G["Tukui"..value]
	if(value == "Bank") then
		bag:ClearAllPoints()
		if C.chat.background == true then
			bag:SetPoint("BOTTOM", TukuiChatBackgroundLeft, "TOP", 0, 3)
		else
			bag:SetPoint("BOTTOM", TukuiInfoLeft, "TOP", 0, 3)
		end	
	end
end
hooksecurefunc(Stuffing, "CreateBagFrame", BagsUpdateBankPosition)