local T, C, L, G = unpack( Tukui )

T.RaidFrameAttributes = function()
	return
		"TukuiRaid",
		nil,
		"solo,raid,party",
		"oUF-initialConfigFunction", [[
			local header = self:GetParent()
			self:SetWidth( header:GetAttribute( "initial-width" ) )
			self:SetHeight( header:GetAttribute( "initial-height" ) )
		]],
		"initial-width", 70,
		"initial-height", 23,
		"showParty", true,
		"showRaid", true,
		"showPlayer", true,
		"showSolo", false,
		"xoffset", T.Scale( 7 ),
		"yOffset", T.Scale( 7 ),
		"point", "LEFT",
		"groupFilter", "1,2,3,4,5,6,7,8",
		"groupingOrder", "1,2,3,4,5,6,7,8",
		"groupBy", "GROUP",
		"maxColumns", 8,
		"unitsPerColumn", 5,
		"columnSpacing", T.Scale( 7 ),
		"columnAnchorPoint", "BOTTOM"
end

T.PostUpdateRaidUnit = function( self )
	------------------------------
	-- misc
	------------------------------
	self.panel:Kill()
	self:SetBackdropColor( 0.0, 0.0, 0.0, 0.0 )

	------------------------------
	-- health
	------------------------------
	self.Health:ClearAllPoints()
	self.Health:SetAllPoints( self )
	self.Health:CreateBorder(false, true)
	self.Health:SetFrameStrata("LOW")

	self.Health.colorDisconnected = false
	self.Health.colorClass = false
	self.Health:SetStatusBarColor( 0.12, 0.12, 0.12, 1 )
	self.Health.bg:SetTexture( 0.2, 0.2, 0.2 )
	if C.unitframes.unicolor == true then
		self.Health.bg:SetVertexColor( 0.6, 0.5, 0.5 )
	else
		self.Health.bg:SetVertexColor( 0.05, 0.05, 0.05 )
	end
	self.Health.value:Point( "CENTER", self.Health, 1, -5 )
	self.Health.value:SetFont( T.CreateFontString() )
	self.Health.value:SetShadowOffset(0, 0)
	
	--Border for the health bar.
	local healthBG = CreateFrame("Frame", healthBG, self.Health)
	healthBG:SetTemplate("Default")
	healthBG:ClearAllPoints()
	healthBG:SetPoint("TOPLEFT", -2, 2)
	healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
	healthBG:CreateBorder(true, true)
	healthBG:SetFrameStrata("Background")
	healthBG:CreateShadow("Default")
	healthBG:HideInsets()

	if( C["unitframes"]["unicolor"] == true ) then
		self.Health.colorDisconnected = false
		self.Health.colorClass = false
		self.Health:SetStatusBarColor( 0.12, 0.12, 0.12, 1 )
		self.Health.bg:SetVertexColor( 0.05, 0.05, 0.05, 1 )
	else
		self.Health.colorDisconnected = true
		self.Health.colorClass = true
		self.Health.colorReaction = true
	end

	if( C["unitframes"]["gradienthealth"] == true and C["unitframes"]["unicolor"] == true ) then
		self:HookScript( "OnEnter", function( self )
			if( not UnitIsConnected( self.unit ) or UnitIsDead( self.unit ) or UnitIsGhost( self.unit ) ) then return end
			local hover = RAID_CLASS_COLORS[select( 2, UnitClass( self.unit ) )]
			if( not hover ) then return end
			self.Health:SetStatusBarColor( hover.r, hover.g, hover.b )
		end)

		self:HookScript( "OnLeave", function( self )
			if( not UnitIsConnected( self.unit ) or UnitIsDead( self.unit ) or UnitIsGhost( self.unit ) ) then return end
			local r, g, b = oUFTukui.ColorGradient( UnitHealth( self.unit ) / UnitHealthMax( self.unit ), unpack( C["unitframes"]["gradient"] ) )
			self.Health:SetStatusBarColor( r, g, b )
		end )
	end

	
	
	-- Power.
	self.Power:Kill()-- Dun want it on the DPS layout. 3:
	
	------------------------------
	-- name
	------------------------------
	self.Name:SetParent( self.Health )
	self.Name:ClearAllPoints()
	self.Name:SetPoint( "CENTER", 0, 5)
	self.Name:SetShadowOffset( 0, 0 )
	self.Name:SetFont( T.CreateFontString() )
	self.Name:SetAlpha(1)

	------------------------------
	-- debuffs
	------------------------------
	if( C["unitframes"]["raidunitdebuffwatch"] == true ) then
		self.RaidDebuffs:Height( 21 * C["unitframes"]["gridscale"] )
		self.RaidDebuffs:Width( 21 * C["unitframes"]["gridscale"] )
		self.RaidDebuffs:Point( "CENTER", self.Health, 2, 1 )

		self.RaidDebuffs.count:ClearAllPoints()
		self.RaidDebuffs.count:SetPoint( "CENTER", self.Health, -2, 2 )
		self.RaidDebuffs.count:SetFont( T.CreateFontString() )

		self.RaidDebuffs.time:ClearAllPoints()
		self.RaidDebuffs.time:SetPoint( "CENTER", self.Health, 0, 0 )
		self.RaidDebuffs.time:SetFont( T.CreateFontString() )
	end

	------------------------------
	-- icons
	------------------------------

	local LFDRole = self.Health:CreateTexture( nil, "OVERLAY" )
	LFDRole:Height( 5 )
	LFDRole:Width( 5 )
	LFDRole:Point( "BOTTOMRIGHT", -2, 2 )
	LFDRole:SetTexture( "Interface\\AddOns\\Tukui\\medias\\textures\\lfdicons.blp" )
	self.LFDRole = LFDRole

	local Resurrect = CreateFrame( "Frame", nil, self.Health )
	Resurrect:SetFrameLevel( self.Health:GetFrameLevel() + 1 )
	Resurrect:Size( 20 )
	Resurrect:SetPoint( "CENTER" )

	local ResurrectIcon = Resurrect:CreateTexture( nil, "OVERLAY" )
	ResurrectIcon:SetAllPoints()
	ResurrectIcon:SetDrawLayer( "OVERLAY", 7 )
	self.ResurrectIcon = ResurrectIcon
end

local TukuiRaidPosition = CreateFrame( "Frame" )
TukuiRaidPosition:RegisterEvent( "PLAYER_LOGIN" )
TukuiRaidPosition:SetScript( "OnEvent", function( self, event )
	local raid = G.UnitFrames.RaidUnits
	local pets = G.UnitFrames.RaidPets
	raid:ClearAllPoints()
	pets:ClearAllPoints()

	raid:SetPoint( "BOTTOMLEFT", TukuiChatBackgroundLeft, "TOPLEFT", 2, 5 )
	pets:SetPoint("LEFT", UIParent, "LEFT", -1000, 0)
end )